import { CreateManyDto, CrudRequest, CrudService, GetManyDefaultResponse } from '@nestjsx/crud';
import { MongoRepository, ObjectLiteral } from 'typeorm';
export declare class TypeOrmMongodbCrudService<T> extends CrudService<T> {
    protected readonly repo: MongoRepository<T>;
    protected entityColumns: string[];
    protected entityPrimaryColumns: string[];
    protected entityRelationsHash: ObjectLiteral;
    protected entityColumnsHash: ObjectLiteral;
    constructor(repo: MongoRepository<T>);
    createMany(req: CrudRequest, dto: CreateManyDto<any>): Promise<T[]>;
    createOne(req: CrudRequest, dto: T): Promise<T>;
    deleteOne(req: CrudRequest): Promise<void | T>;
    getMany(req: CrudRequest): Promise<GetManyDefaultResponse<T> | T[]>;
    getOne(req: CrudRequest): Promise<T>;
    replaceOne(req: CrudRequest, dto: T): Promise<T>;
    updateOne(req: CrudRequest, dto: T): Promise<T>;
    protected onInitMapRelations(): void;
    protected onInitMapEntityColumns(): void;
    private getOneOrFail;
    private createCursor;
    private doGetMany;
    createPageInfo(data: T[], total: number, limit: number, offset: number): GetManyDefaultResponse<T>;
    private getSelect;
    private getSort;
    private mapSort;
    private getAllowedColumns;
    private setSearchCondition;
    private setSearchFieldObjectCondition;
    private builderAddBrackets;
    private builderSetWhere;
    private setAndWhere;
    private setOrWhere;
    private mapOperatorsToQuery;
    private checkFilterIsArray;
}
